/*--------------------------------------------------------------------------
Copyright (c) 2010 - 2013, The Linux Foundation. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of The Linux Foundation nor
      the names of its contributors may be used to endorse or promote
      products derived from this software without specific prior written
      permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--------------------------------------------------------------------------*/
#ifndef QTYPES_H
#define QTYPES_H
/*===========================================================================

                            Data Declarations

===========================================================================*/

#ifdef __cplusplus
extern "C" {
#endif

/* ------------------------------------------------------------------------
** Constants
** ------------------------------------------------------------------------ */

#ifdef TRUE
#undef TRUE
#endif

#ifdef FALSE
#undef FALSE
#endif

#define TRUE   1   /* Boolean true value. */
#define FALSE  0   /* Boolean false value. */



/* -----------------------------------------------------------------------
** Standard Types
** ----------------------------------------------------------------------- */

    /* The following definitions are the same accross platforms.  This first
     ** group are the sanctioned types.
     */

    typedef  unsigned char      boolean;     /* Boolean value type. */

    typedef  unsigned int  uint32;      /* Unsigned 32 bit value */
    typedef  unsigned short     uint16;      /* Unsigned 16 bit value */
    typedef  unsigned char      uint8;       /* Unsigned 8  bit value */

    typedef  int    int32;       /* Signed 32 bit value */
    typedef  signed short       int16;       /* Signed 16 bit value */
    typedef  signed char        int8;        /* Signed 8  bit value */

    /* This group are the deprecated types.  Their use should be
     ** discontinued and new code should use the types above
     */
    typedef  unsigned char     byte;         /* Unsigned 8  bit value type. */
    typedef  unsigned short    word;         /* Unsinged 16 bit value type. */
    typedef  unsigned long     dword;        /* Unsigned 32 bit value type. */

    typedef long long           int64;
    typedef unsigned long long  uint64;


#ifdef __cplusplus
}
#endif

#endif  /* QTYPES_H */
